/***************************************************************************
                          kountdown.h  -  description
                             -------------------
    begin                : Sun Feb 10 09:52:20 CET 2002
    copyright            : (C) 2002 by Erik Johansson
    email                : erre@telia.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KOUNTDOWN_H
#define KOUNTDOWN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kscreensaver.h>

class QColor;
class QFont;
class QString;
class QPixmap;

class Timer;

/**
* Kountdown is the screensaver.
*/
class Kountdown : public KScreenSaver
{
  Q_OBJECT 
  public:
		Kountdown( WId drawable );
		virtual ~Kountdown();

	protected:
		void timerEvent( QTimerEvent * );
		void paintEvent( QPaintEvent * );

	public slots:
		void readSettings(int);

	private:
		void readGlobalSettings();
		void kountdown();

		// Settings, set after current setting (start, half, finish)
		QColor backCol, fontCol;
		QString text;
		QFont font;				
		QString textDisplay, oldTimeString;

		Timer *timer;				// The timer that counts down
		int timers;						// The timer that updates the time (every 300 ms)
		QPixmap *qpixmap;  	// Paint in this, bitBlt it to the screen
		bool repaintScreen;	// Do we need to update the pixmap, or just bitBlt it to the screen
};

#endif
